# -- Misc utils ----------------------------------------------------------------------#

#' @importFrom data.table ":="
NULL


#' Get template for a new resource instance
#'
#' @param resource Name of resource type.
tempJSON <- function(resource = c("Antibody", "Assay", "Proteomics")) {
  res <-
    try(jsonlite::fromJSON(
      paste0(
        "https://test-resourcebrowser.azurewebsites.net/api/v1.0/AdminResource/GetNew/",
        resource
      )
    ))
  if (class(res) != "try-error")
    return(res)
  else
    return(NULL)
}

#'  Recursively modify R list structure so that toJSON will be in the correct format
#'  @param x A list.
#' @keywords internal
unboxR <- function(x) {
  if(length(x) == 0) return(NA)
  if(!is.list(x[[1]])) return(unlist(x))
  else {
    r <- lapply(x, unboxR)
    r[names(r) == "Tags"][[1]] <- list() ## keep Tags as array
    r
  }
}

#' Package resource list as JSON payload for loading
#'
#' The `loadlist` is a list typically generated by splitting resources into their type,
#' e.g. should look like `list(Antibody = list(..), Assay = list(..), ...)`.
#' 
#' @param loadlist An R list.
#' @param batch String batch id.
#' @export
packageResourceLoad <- function(loadlist, batch) {
  resource_load <- httr::content(getSampleLoadJson())
  
  # Default each resource type to an empty list initially
  for(i in seq_along(resource_load)) {
    if(!names(resource_load[i]) %in% c("ResourceType", "BatchIdentifier", "DateSubmitted")) resource_load[[i]] <- list()
  }
  resource_load$BatchIdentifier <- batch
  resource_load$ResourceType <- ""
  
  # Stick elements in right position
  for(subtype in names(loadlist)) {
    resource_load[[paste0(subtype, "Resources")]] <- loadlist[[subtype]]
  }
  
  resource_load <- jsonlite::toJSON(resource_load, null = "null", na = "null", auto_unbox = T)
  return(resource_load)
}

#' Read .csv into cleaned data.table
#' 
#' Reads Airtable-exported .csv and cleans up a couple of things 
#' that would otherwise generate errors downstream,
#' such as removing extra quotes and switching to pipes (|) 
#' to separate multiple-select entries in a field.
#' 
#' @param csv File.
#' @param cols Columns.
#' @export
readCsvExport <- function(csv, cols) {
  x <- data.table::fread(csv, colClasses = "character", na.strings = NULL)
  # cols that need to be formatted:
  
  for(col in cols) {
    data.table::set(x, j = col, value = formatCol(x[[col]]))
  }
  return(x)
}

#' Format a list column in exported .csv file
#' 
#' Note that this is tested specifically for Airtable-exported files.
#' 
#' @param col A list (multiple-select) column with entries separated by ",".
formatCol <- function(col) {
  col <- gsub('\"', '', col) 
  col <- strsplit(col, ",(?! )", perl = T)
  col <- sapply(col, function(x) paste(x, collapse = "|"))
  return(col)
}

#' Read batch template file
#' 
#' Formats list columns as character separated by pipes (|)
#' @param file File path.
readTemplate <- function(file) {
  x <- data.table::fread(file, colClasses = "character", na.strings = NULL)
  for(col in names(x)) {
    if(class(x[[col]]) == "list") data.table::set(x, j = col, value = sapply(x[[col]], paste, collapse = "|"))
  }
  return(x)
}


#' Split fields to pre-determined specification
#' 
#' Fields that contain multiple values MUST use pipe ("|") separator,
#' which this utility function assumes for routine parsing.
#' It is used within all `*_json` functions that convert resource records to JSON.
#' 
#' @param field One-character vector representing a field.
specSplit <- function(field) {
  strsplit(field, split = "|", fixed = T)[[1]]
}